/*
  Melody
 
 Plays a melody 
 
 circuit:
 * 8-ohm speaker on digital pin 8
 
 created 21 Jan 2010
 by Tom Igoe 
 
 http://arduino.cc/en/Tutorial/Tone
 
 mod by SaTa.
 */
#include <avr/pgmspace.h>
#include <EEPROM.h>

#include "pz_data_0.h"
#include "pz_data_1.h"
#include "pz_data_2.h"
#include "pz_data_3.h"
#include "pz.h"

#include "led4.h"

#define LEDPIN 7     // どのピンからLEDをつなぐか
#define LEDPIN_MAX 7     // LED数
#define SWPIN 2      // スイッチをつなぐピン
#define SPKPIN 14      //  スピーカ

#define MAX_PZ (4)

unsigned int pz_no=0;
void pz_data_r(int i,unsigned char *a,unsigned char *b)
{
//  typeof(prog_uchar *) pz_data_ab[MAX_PZ]={pg_pz_data,pg_pz_data2,pg_pz_data3,pg_pz_data4,pg_pz_data5,pg_pz_data6};
  typeof(prog_uchar *) pz_data_ab[MAX_PZ]={pg_pz_data0,pg_pz_data1,pg_pz_data2,pg_pz_data3, };
  typeof(prog_uchar *) pz_data_w=pz_data_ab[pz_no % MAX_PZ];
//    switch(pz_no % MAX_PZ)
        *a=(unsigned char)pgm_read_byte_near(pz_data_w+i*2);
        *b=(unsigned char)pgm_read_byte_near(pz_data_w+i*2+1);
}


int ledPin=LEDPIN;
//int w=0;
int t=60;
float dt=0;
long i= 1;
long j=0;
//unsigned char *pz_data=pgm_read_word_near(pg_pz_data);
unsigned char a,b;

void setup() {
//テンポを計算する
//pz_data=pgm_read_word_near(pg_pz_data);
Serial.begin(9600); 

pinMode(SWPIN, INPUT);      // スイッチのピンを入力に
digitalWrite(SWPIN, HIGH);  // 内蔵プルアップ有効

for(j=0;j<LEDPIN_MAX;j++)
{
  pinMode(LEDPIN+j, OUTPUT);      // 出力に
}

// メモリ初期化

char flg=0;
char rt=0;
char data[4];
char MAGIC_CODE[5]="TMS0";

int val;
int v_max,v_min;

for(j=0;j<4;j++)
{
data[j] = EEPROM.read(j);
if(data[j]==MAGIC_CODE[j])flg++;
}



  if(flg<4)
  {
      for(j=0;j<4;j++)
      {
      EEPROM.write(j,MAGIC_CODE[j]) ;
      }
      EEPROM.write(4,1); 
  }
  else
  {
      rt=EEPROM.read(4);
      EEPROM.write(4,rt+1); 
  }




  if(rt%(MAX_PZ+1)==0)
  {
    tone(14, 880,500);
    delay(1000);
    
      for(;;)
      {
        led_test();
         for(j=0;j<LEDPIN_MAX;j++)
         {
            digitalWrite(LEDPIN+j, HIGH);   // set the LED on
          delay(100);
         }
           
    
         for(j=0;j<LEDPIN_MAX;j++)
         {
            digitalWrite(LEDPIN+j, LOW);    // set the LED off
          delay(100);
          }
      }

  }
  pz_no=(rt%(MAX_PZ+1))-1;
     LED4_init();        


}

void print_tone(int i)
{
    int w,o;
    char str[8];
    const char *nt[]=
    {
      "C","C+","D","D+","E","F","F+","G","G+","A","A+","B"
    };
    
    if(i==0)
    {
      LED4_print("----");
      return;
    }
    i=i+9;
    w=i%12;
    t=i/12;
    sprintf(str,"O%d%s  ",t,nt[w]);
    LED4_print(str);
}

      int p=0;
      int vl=0;

void loop() {

  pz_data_r(0,&a,&b);
  t=a;
  
  dt=60000/t/48  ;  // 1clockの時間

  for (; ;i++) 
  {
    pz_data_r(i,&a,&b);
    if(a==0 && b==0)  {i=1;pz_data_r(i,&a,&b);}
  
    for(j=0;j<LEDPIN_MAX;j++)
    {
      ledPin=LEDPIN+LEDPIN_MAX-j-1;
        if(a==0)
        {
        digitalWrite(ledPin, LOW);    // set the LED off
        }
        else
        {
        digitalWrite(ledPin, HIGH);   // set the LED on
        }
    }
    

    p =  b * dt;  // 音の長さ
     
//    if(digitalRead(SWPIN)==LOW)    // スイッチが入るとテンポアップ
//    {
//        p =  b * dt/4;  // 音の長さ
//    }

    tone(14, pz_hz[ a ],p);
    print_tone(a);
//    {
//          char str[16];
//          sprintf(str,"%4d    ",pz_hz[ a ]);
//          LED4_print(str);
//    }
    
    

#define VL (10)
vl=VL;
    for(j=0;j<LEDPIN_MAX;j++)
    {
         if(p-vl<=0)
         {
           
           break;
         }
          p=p-vl;

          delay(vl-1);
          vl=vl+vl;
          ledPin=LEDPIN+LEDPIN_MAX-j-1;
            digitalWrite(ledPin, LOW);    // set the LED off
    }


    delay(p);
    
//    for(j=0;j<7;j++)
//    {
//      ledPin=LEDPIN+j;
//        digitalWrite(ledPin, LOW);    // set the LED off
//    }
    


    
  }  

}


void led_test(void)
{
  char str[16];
       LED4_init();   
          LED4_print("    ");
        delay(100);
        LED4_print("H   ");
        delay(250);
        LED4_print(" E  ");
        delay(250);
        LED4_print("  L ");
        delay(250);
        LED4_print("   O");
        delay(250);
        LED4_print("HELO");
        delay(250);
        for(i=0;i<10;i++)
        {
        LED4_send(LED4_CMD_ALL_OFF);
        delay(250);
        LED4_send(LED4_CMD_NOMAL);
        delay(250);
        }

        
        for(i=0;i<10000;i++)
        {
          i*=1.001;

              sprintf(str,"%4d    ",i);
            tone(14, i);
            delay(1);
          LED4_print(str);
          // delay(10);
        }
            noTone(14);

}


