

#include <wiring.h>
#include "led4.h"


void LED4_send(unsigned short data)
{
    int x;
//    char str[16];
//   Serial.print("LED4_send");
//   sprintf(str,"(%04X) ",data);
//   Serial.print(str);
    for(x=15;x>=0;x--)
    {
        led4_ck(LED4_OFF);
        if(x==15){led4_ld(LED4_ON);}
        if( data & (1 << x))         
        {          
          led4_di(LED4_ON);
//           Serial.print("H");
        }        
        else        
        {          
          led4_di(LED4_OFF);
//           Serial.print("L");
        }        
        delayMicroseconds(LED4_WAIT);
//        delay(LED4_WAIT);
        led4_ck(LED4_ON);
        if(x==15){led4_ld(LED4_OFF);}
        delayMicroseconds(LED4_WAIT);
//        delay(LED4_WAIT);
    }
//           Serial.println("<");
}

void LED4_init(void)
{
  pinMode(LED4_CK, OUTPUT);      // 
  digitalWrite(LED4_CK, HIGH);  // 
  pinMode(LED4_LD, OUTPUT);      // 
  digitalWrite(LED4_LD, LED4_OFF);  // 
  pinMode(LED4_DI, OUTPUT);      // 
  digitalWrite(LED4_DI, LED4_OFF);  // 

  
  LED4_send(LED4_CMD_ALL_OFF);
  LED4_send(LED4_CMD_NOMAL);
//  LED4_send(LED4_CMD_ALL_ON);
  
}



int LED4_seg(char x)
{
    switch(x)
    {
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
            return x-'0';
        break;
        case 'A':
        case 'B':
        case 'C':
        case 'D':
        case 'E':
        case 'F':
            return x-'A'+10;
        break;
        case 'a':
        case 'b':
        case 'c':
        case 'd':
        case 'e':
        case 'f':
            return x-'a'+10;
        break;
        case ' ':
            return 0x10;
        break;
        case '-':
            return 0x1A;
        break;
        case '+':
            return 0x1E;
        break;
        case 'g':
        case 'G':
            return 0x06;
        break;
        case 'h':
        case 'H':
            return 0x11;
        break;
        case 'i':
        case 'I':
            return 0x01;
        break;
        case 'j':
        case 'J':
            return 0x12;
        break;
        case 'k':
        case 'K':
            return 0x5A;
        break;
        case 'l':
        case 'L':
        case 'm':
        case 'M':
        case 'n':
        case 'N':
            return 0x13;
        break;
        case 'o':
        case 'O':
            return 0x1C;
        break;
        case 'p':
        case 'P':
            return 0x14;
        break;
        case 'q':
        case 'Q':
            return 0x15;
        break;
        case 'r':
        case 'R':
            return 0x16;
        break;
        case 's':
        case 'S':
            return 0x17;
        break;
        case 't':
        case 'T':
            return 0x5A;
        break;
        case 'u':
        case 'U':
            return 0x18;
        break;
        case 'v':
        case 'V':
            return 0x58;
        break;
        case 'w':
        case 'W':
            return 0x58;
        break;
        case 'x':
        case 'X':
            return 0x51;
        break;
        case 'y':
        case 'Y':
            return 0x19;
        break;
        case 'z':
        case 'Z':
            return 0x42;
        break;
        case '!':
            return 0x41;
        break;
    }
    return 0x50;    
}


void LED4_print(char *str)
{
    int i;
    unsigned short out;
    for(i=0;i<4;i++)
    {
        if(str[i]==0)break;
        out=LED4_CMD_REG + LED4_REG_NO*i+LED4_seg(str[i]);
        LED4_send(out);      
    }
        LED4_send(LED4_CMD_NOMAL);
}


