/*

 TOSHIBA TB62709NG  7-segment drivers


 Arduino PIN    TB62709NG PIN
 D2              2 DATA-IN
 D3              3 CLOCK
 D4              4 LOAD

 by SaTa.
 */
//#include <wiring.h>

#define LED4_DI (2)
#define LED4_CK (3)
#define LED4_LD (4)


#define LED4_CMD_ALL_OFF 0x0000
#define LED4_CMD_ALL_ON  0x3000
#define LED4_CMD_NOMAL   0x1000
#define LED4_CMD_REG     (0x2200)
#define LED4_REG_NO      (0x0100)


/*
(2) DATA-IN(DI)
(3) CLOCK  (CK) 15MHz  1KHz=1000マイクロ秒～1MHz=1マイクロ秒  減らして測定
(4) LOAD   (LD)

clk=1000/2 (1kHz)
ステップ
        CK OFF
        LD ON   bit:15 かつ 初回でない場合
        DI:bit15～0
        delay(clk)
        CK ON
        LD OF   bit:15 かつ 初回でない場合
        delay(clk)


DI   (15    )(14    )(13    )(12    )(11    )(10    )(9     )(8     )(7     )(6     )(5     )(4     )(3     )(2     )(1     )(0     )
CK   ____----____----____----____----____----____----____----____----____----____----____----____----____----____----____----____----
LD   ----____________________________________________________________________________________________________________________________

*/
#define LOW (0x00)
#define HIGH (0x01)
#define LED4_WAIT (1)
//#define LED4_WAIT (200)
//#define LED4_ON (HIGH)
//#define LED4_OFF (LOW)
#define LED4_ON (HIGH)
#define LED4_OFF (LOW)
#define led4_ck(x) digitalWrite(LED4_CK, x)
#define led4_ld(x) digitalWrite(LED4_LD, x)
#define led4_di(x) digitalWrite(LED4_DI, x)


void LED4_send(unsigned short data);

void LED4_init(void);

int LED4_seg(char x);

void LED4_print(char *str);


